package com.fcbox.bluetooth.core

import android.bluetooth.BluetoothAdapter
import android.content.BroadcastReceiver
import android.content.Context
import android.content.Intent
/**
 * @Description:蓝牙广播接收
 * @Author: luobin
 * @Date:   2021/4/28
 * @License: Copyright Since 2020 Hive Box Technology. All rights reserved.
 * @Notice: This content is limited to the internal circulation of Hive Box, 
 * and it is prohibited to leak or used for other commercial purposes.
 */
class BluetoothStateReceiver : BroadcastReceiver() {
    private var blueToothConnectCallBack: BlueToothConnectCallBack? = null

    fun setBlueToothConnectCallBack(blueToothConnectCallBack: BlueToothConnectCallBack?) {
        this.blueToothConnectCallBack = blueToothConnectCallBack
    }

    override fun onReceive(context: Context, intent: Intent) {
        val state = intent.getIntExtra(BluetoothAdapter.EXTRA_STATE, -1)
        when (state) {
            BluetoothAdapter.STATE_TURNING_ON ->

                blueToothConnectCallBack?.call(
                    CallBackMsg.newInstance(
                        BlueToothConstant.MESSAGE_BLUETOOTH_ON,
                        0,
                        0,
                        null,
                        null
                    )
                )


            BluetoothAdapter.STATE_TURNING_OFF ->
                blueToothConnectCallBack?.call(
                    CallBackMsg.newInstance(
                        BlueToothConstant.MESSAGE_BLUETOOTH_OFF,
                        0,
                        0,
                        null,
                        null
                    )
                )
        }


    }
}