//package com.fcbox.printer.base
//
//import com.fcbox.printer.bean.PrintConfig
//import com.fcbox.printer.opt.BoxOpt
//import com.fcbox.printer.opt.LineOpt
//import com.fcbox.printer.opt.OverOpt
//import com.fcbox.printer.opt.ReadyOpt
//import java.util.*
//
///**
// * @author: 朱丽君
// * @create: 20-4-17 下午12:05
// * @description: 基础面单模板
// *
// */
//abstract class BaseTemplate : IPrintTemplate {
//    @JvmField
//    protected val EMPTY_OPT: List<IPrintOpt> = ArrayList()
//
//    @JvmField
//    protected var templateLineWidth = 1 //线条的宽
//
//    @JvmField
//    protected var templateBarCodeAreaHeight = 31 //条码区高度
//
//    @JvmField
//    protected var templateExpressCodeAreaHeight = 8 //运单区域
//
//    @JvmField
//    protected var templateReceiverAreaHeight = 14 //收件人区域
//
//    @JvmField
//    protected var templateSendAreaHeight = 12 //寄件人区域
//
//    @JvmField
//    protected var templateInfoAreaHeight = 30 //快递信息区域
//
//
//    private var templateBaseLeft = 2 //左边间距
//
//
//    private var templateBaseTop = 11 //顶部间距
//
//    private var templateRectWidth = 70 //表格区域宽度
//
//
//    private var baseBarAreaTop = 0
//    private var baseExpressTop = 0
//    private var baseReceiverTop = 0
//    private var baseSenderTop = 0
//    private var baseInfoTop = 0
//
//    open fun setTemplateBaseTop(templateBaseTop: Int) {
//        this.templateBaseTop = templateBaseTop
//    }
//    open fun setTemplateBaseLeft(templateBaseLeft: Int) {
//        this.templateBaseLeft = templateBaseLeft
//    }
//    open fun setTemplateRectWidth(templateRectWidth: Int) {
//        this.templateRectWidth = templateRectWidth
//    }
//
//
//    @JvmField
//    protected var bean: Any? = null
//
//    protected lateinit var printConfig: PrintConfig
//
//    /*
//    logo区
//  */
//    abstract fun getLogoOpts(): List<IPrintOpt>
//
//    /*
//   条码区
//   */
//    abstract fun getBarCodeOpts(): List<IPrintOpt>
//
//    /*
//   运单区
//   */
//    abstract fun getExpressCodeOpts(): List<IPrintOpt>
//
//    /*
//   收件人区
//   */
//    abstract fun getReceiverOpts(): List<IPrintOpt>
//
//    /*
//   寄件人区
//   */
//    abstract fun getSenderOpts(): List<IPrintOpt>
//
//    /*
//   快递信息区
//   */
//    abstract fun getInfoOpts(): List<IPrintOpt>
//
//    private val allPrintOpt: MutableList<IPrintOpt> = ArrayList()
//
//    override fun convert2Opts(): List<IPrintOpt> {
//        if (bean == null) {
//            return listOf()
//        }
//
//        initSizeParams()
//
//        allPrintOpt.add(ReadyOpt.create())
//
//        //logo区(第一栏)
//        val logoOpts = getLogoOpts()
//        if (logoOpts.isEmpty().not()) {
//            addPrintOptList(logoOpts, 0)
//        }
//
//
//        allPrintOpt.add(
//            BoxOpt.create(
//                templateBaseLeft.toDouble(),
//                templateBaseTop.toDouble(),
//                (templateBaseLeft + templateRectWidth).toDouble(),
//                (templateBaseTop
//                        + templateBarCodeAreaHeight
//                        + templateExpressCodeAreaHeight
//                        + templateReceiverAreaHeight
//                        + templateSendAreaHeight
//                        + templateInfoAreaHeight).toDouble(),
//                templateLineWidth
//            )
//        )
//
//
//        //条码区
//        addPrintOptList(getBarCodeOpts(), baseBarAreaTop)
//
//        //运单区
//        val expressCodeOpts = getExpressCodeOpts()
//        if (expressCodeOpts.isEmpty().not()) {
//            allPrintOpt.add(
//                LineOpt.create(
//                    templateBaseLeft.toDouble(),
//                    baseExpressTop.toDouble(),
//                    (templateBaseLeft + templateRectWidth).toDouble(),
//                    baseExpressTop.toDouble(),
//                    1
//                )
//            )
//            addPrintOptList(expressCodeOpts, baseExpressTop)
//        }
//
//        //收件人区
//        val receiverOpts = getReceiverOpts()
//        if (receiverOpts.isEmpty().not()) {
//            allPrintOpt.add(
//                LineOpt.create(
//                    templateBaseLeft.toDouble(),
//                    baseReceiverTop.toDouble(),
//                    (templateBaseLeft + templateRectWidth).toDouble(),
//                    baseReceiverTop.toDouble(),
//                    1
//                )
//            )
//            addPrintOptList(receiverOpts, baseReceiverTop)
//        }
//
//
//        //寄件人区
//        val senderOpts = getSenderOpts()
//        if (senderOpts.isEmpty().not()) {
//            allPrintOpt.add(
//                LineOpt.create(
//                    templateBaseLeft.toDouble(),
//                    baseSenderTop.toDouble(),
//                    (templateBaseLeft + templateRectWidth).toDouble(),
//                    baseSenderTop.toDouble(),
//                    1
//                )
//            )
//            addPrintOptList(senderOpts, baseSenderTop)
//        }
//
//
//        //info
//        val infoOpts = getInfoOpts()
//        if (infoOpts.isEmpty().not()) {
//            allPrintOpt.add(
//                LineOpt.create(
//                    templateBaseLeft.toDouble(),
//                    baseInfoTop.toDouble(),
//                    (templateBaseLeft + templateRectWidth).toDouble(),
//                    baseInfoTop.toDouble(),
//                    1
//                )
//            )
//            addPrintOptList(infoOpts, baseInfoTop)
//        }
//        allPrintOpt.add(OverOpt.create())
//        return allPrintOpt
//    }
//
//    private fun addPrintOptList(printOptList: List<IPrintOpt>?, baseAlignY: Int) {
//        if (printOptList.isNullOrEmpty()) {
//            return
//        }
//
//        printOptList.forEach {
//            it.setBaseXY(templateBaseLeft, baseAlignY)
//            allPrintOpt.add(it)
//        }
//    }
//
//    fun setPrintData(bean: Any?): BaseTemplate {
//        this.bean = bean
//        return this
//    }
//
//    fun setPrintConfig(printConfig: PrintConfig): BaseTemplate {
//        this.printConfig = printConfig
//        return this
//    }
//
//    //子类重新赋值了，注意初始化顺序
//     open fun initSizeParams() {
//        baseBarAreaTop = templateBaseTop
//        baseExpressTop = baseBarAreaTop + templateBarCodeAreaHeight
//        baseReceiverTop = baseExpressTop + templateExpressCodeAreaHeight
//        baseSenderTop = baseReceiverTop + templateReceiverAreaHeight
//        baseInfoTop = baseSenderTop + templateSendAreaHeight
//    }
//
//    companion object {
//        @JvmField
//        var UNIT_RATIO = 8 //mm 单位到具体打印机的 系数
//    }
//}