package com.fcbox.printer.bean

/**
 * @Description: 打印基本参数
 * @Author: luobin
 * @Date:   2021/4/23
 * @License: Copyright Since 2020 Hive Box Technology. All rights reserved.
 * @Notice: This content is limited to the internal circulation of Hive Box, 
 * and it is prohibited to leak or used for other commercial purposes.
 */
class PrintConfig private constructor(
    val instructionType: InstructionType,
    val businessType: String,
    val expressCompany: String ,
    val printerType: PrinterType
) {

    data class Builder(
        var instructionType: InstructionType = InstructionType.CPCL,
        var businessType: String = "LABEL",
        var expressCompany: String= "SF",
        var printerType: PrinterType= PrinterType.SNBC
    ) {
        fun commandType(instructionType: InstructionType) =
            apply { this.instructionType = instructionType }

        fun printerType(printerType: PrinterType) = apply { this.printerType = printerType }

        fun businessType(businessType: String) = apply { this.businessType = businessType }

        fun expressCompany(expressCompany: String) =
            apply { this.expressCompany = expressCompany }

        fun build() = PrintConfig(instructionType=instructionType,
            businessType= businessType,
            expressCompany= expressCompany,
            printerType= printerType
        )
    }
}