package com.fcbox.printer.device

import com.fcbox.printer.bean.PrinterType
import com.fcbox.template.BaseTemplate

/**
 * @Description:
 * @Author: luobin
 * @Date:   2021/5/7
 * @License: Copyright Since 2020 Hive Box Technology. All rights reserved.
 * @Notice: This content is limited to the internal circulation of Hive Box, 
 * and it is prohibited to leak or used for other commercial purposes.
 */
class PrinterFactory {

    companion object {

        fun generatePrinter(printerType: PrinterType, template: BaseTemplate): PrinterDecorator {

            when (printerType) {
                PrinterType.SNBC -> {
                    return BTPPrinter(template)
                }
                PrinterType.OTHER -> {
                }
            }
            return NormalPrinter(template)
        }
    }


}