package com.fcbox.printer.manager

import com.fcbox.printer.base.IPrintAdapter
import com.fcbox.printer.bean.InstructionType

/**
 * @Description: 指令集适配器 Manager
 * @Author: luobin
 * @Date:   2021/4/26
 * @License: Copyright Since 2020 Hive Box Technology. All rights reserved.
 * @Notice: This content is limited to the internal circulation of Hive Box, 
 * and it is prohibited to leak or used for other commercial purposes.
 */
class InstructionAdapterManager {

    private val instructionTypeMap = hashMapOf<InstructionType, IPrintAdapter>()

    fun registerAdapter(instructionType: InstructionType, printAdapter: IPrintAdapter) {
        instructionTypeMap[instructionType] = printAdapter
    }

    fun getPrintAdapter(instructionType: InstructionType): IPrintAdapter? {
        return instructionTypeMap[instructionType]
    }


}