package com.fcbox.printer.manager

import com.fcbox.printer.template.CompanyBusinessPrinterTemplate
import com.fcbox.template.BaseTemplate

/**
 * @Description: 模板Manager
 * @Author: luobin
 * @Date:   2021/4/26
 * @License: Copyright Since 2020 Hive Box Technology. All rights reserved.
 * @Notice: This content is limited to the internal circulation of Hive Box, 
 * and it is prohibited to leak or used for other commercial purposes.
 */
class TemplateManager {

    private val map = hashMapOf<String, CompanyBusinessPrinterTemplate>()

    fun registerTemplate(clazz: Class<out CompanyBusinessPrinterTemplate>) {
        val template = clazz.newInstance()
        map[template.company()] = template
    }


    fun getTemplate(
        businessType: String,
        expressCompany: String,
    ): Class<out BaseTemplate>? {
        return map[expressCompany]?.getPrinterTemplate(businessType)
    }


    fun destroy() {
        map.clear()
    }
}