package com.fcbox.printer.opt

import com.fcbox.template.IPrintOpt

/**
 * @Description: 对齐方式
 * @Author: luobin
 * @Date:   2021/4/26
 * @License: Copyright Since 2020 Hive Box Technology. All rights reserved.
 * @Notice: This content is limited to the internal circulation of Hive Box, 
 * and it is prohibited to leak or used for other commercial purposes.
 */
class AlignOpt : IPrintOpt {
    override var optCode = OptTable.OPT_ALIGIN
    private lateinit var type: String

    fun getType(): String {
        return type
    }

    fun setType(type: String) {
        this.type = type
    }

    override fun setBaseXY(baseX: Int, baseY: Int) {}

    companion object {
        const val ALIGN_LEFT = "LEFT"
        const val ALIGN_RIGHT = "RIGHT"
        const val ALIGN_CENTER = "CENTER"

        @JvmStatic
        fun create(type: String): AlignOpt {
            val opt = AlignOpt()
            opt.type = type
            return opt
        }
    }


}

