package com.fcbox.printer.opt

import android.graphics.Bitmap
import com.fcbox.template.IPrintOpt
/**
 * @Description: bitmap
 * @Author: luobin
 * @Date:   2021/4/26
 * @License: Copyright Since 2020 Hive Box Technology. All rights reserved.
 * @Notice: This content is limited to the internal circulation of Hive Box, 
 * and it is prohibited to leak or used for other commercial purposes.
 */
class BitmapOpt : IPrintOpt {
    override var optCode = OptTable.OPT_CODE_BITMAP
    private var bitmapWidth = 0
    private var bitmapHeight = 0
    private var x = 0.0
    private var y = 0.0
    var octetStr: String? = null
    private var bmp: Bitmap? = null

    fun getBitmapWidth(): Int {
        return bitmapWidth
    }

    fun getBitmapHeight(): Int {
        return bitmapHeight
    }

    fun getX(): Double {
        return x
    }

    fun getY(): Double {
        return y
    }

    fun setBitmapWidth(width: Int) {
        bitmapWidth = width
    }

    fun setBitmapHeight(bitmapHeight: Int) {
        this.bitmapHeight = bitmapHeight
    }

    fun setX(x: Double) {
        this.x = x
    }

    fun setY(y: Double) {
        this.y = y
    }

    fun getBmp(): Bitmap? {
        return bmp
    }

    fun setBmp(bmp: Bitmap?) {
        this.bmp = bmp
    }

    override fun setBaseXY(baseX: Int, baseY: Int) {
        setX(x + baseX)
        setY(y + baseY)
    }

    fun transToHexString(b: ByteArray): String {
        var a = ""
        for (i in b.indices) {
            var hex = Integer.toHexString(b[i].toInt() and 255)
            if (hex.length == 1) {
                hex = "0$hex"
            }
            a += hex
        }
        return a
    }

    companion object {
        @JvmStatic
        fun create(
            x: Double, y: Double, bitmapWidth: Int, bitmapHeight: Int,
            bmp: Bitmap?
        ): BitmapOpt {
            val opt = BitmapOpt()
            opt.bitmapWidth = bitmapWidth
            opt.bitmapHeight = bitmapHeight
            opt.x = x
            opt.y = y
            opt.bmp = bmp
            return opt
        }
    }
}