package com.fcbox.printer.opt

import com.fcbox.template.IPrintOpt
/**
 * @Description: 直线
 * @Author: luobin
 * @Date:   2021/4/26
 * @License: Copyright Since 2020 Hive Box Technology. All rights reserved.
 * @Notice: This content is limited to the internal circulation of Hive Box, 
 * and it is prohibited to leak or used for other commercial purposes.
 */
class LineOpt : IPrintOpt {
    override var optCode = OptTable.OPT_CODE_LINE
    private var beginX = 0.0 // x轴起始坐标

    private var beginY = 0.0 // y轴起始坐标
    private var endX = 0.0 // x轴结束坐标
    private var endY = 0.0 // y轴结束坐标
    private var width = 0 // 线段宽度


    fun getBeginX(): Double {
        return beginX
    }

    fun getBeginY(): Double {
        return beginY
    }

    fun getEndX(): Double {
        return endX
    }

    fun getEndY(): Double {
        return endY
    }

    fun getWidth(): Int {
        return width
    }

    fun setBeginX(beginX: Double) {
        this.beginX = beginX
    }

    fun setBeginY(beginY: Double) {
        this.beginY = beginY
    }

    fun setEndX(endX: Double) {
        this.endX = endX
    }

    fun setEndY(endY: Double) {
        this.endY = endY
    }

    fun setWidth(width: Int) {
        this.width = width
    }

    override fun setBaseXY(baseX: Int, baseY: Int) {
        setBeginX(beginX + baseX)
        setEndX(endX + baseX)
        setBeginY(beginY + baseY)
        setEndY(endY + baseY)
    }

    companion object {
        /**
         * @param beginX x轴起始坐标
         * @param beginY y轴起始坐标
         * @param endX x轴结束坐标
         * @param endY y轴结束坐标
         * @param width 线段宽度
         */
        @JvmStatic
        fun create(
            beginX: Double, beginY: Double, endX: Double, endY: Double,
            width: Int
        ): LineOpt {
            val opt = LineOpt()
            opt.beginX = beginX
            opt.beginY = beginY
            opt.endX = endX
            opt.endY = endY
            opt.width = width
            return opt
        }
    }
}