package com.fcbox.printer.opt

/**
 * @Description: 相关常量
 * @Author: luobin
 * @Date:   2021/4/26
 * @License: Copyright Since 2020 Hive Box Technology. All rights reserved.
 * @Notice: This content is limited to the internal circulation of Hive Box, 
 * and it is prohibited to leak or used for other commercial purposes.
 */
object OptTable {

    const val OPT_CODE_NOP = 0 // 空指令, 无实际含义
    const val OPT_CODE_READY = 10 // 准备指令, 必须为一组指令list中的first指令,表示预备打印
    const val OPT_CODE_OVER = 11 // 完成指令,  必须为一组指令list中的last指令,表示已完成指令发送,等待打印机打印
    const val OPT_CODE_TEXT = 12 // 文字
    const val OPT_CODE_LINE = 13 // 线段
    const val OPT_CODE_BARCODE = 14 // 一维条码
    const val OPT_CODE_QRCODE = 15 // 二维条码
    const val OPT_CODE_BITMAP = 16 // 点阵图像
    const val OPT_CODE_BOX = 17 // 矩形框图像
    const val OPT_ALIGIN = 18 // 对齐指令 ，对文本和一维码有效
    const val BARCODE_TYPE_128 = 1 // Code 128 (Auto) 条形码

    const val QRCODE_LEVEL_L = 1 // 7% 容错率
    const val QRCODE_LEVEL_M = 2 // 15% 容错率
    const val QRCODE_LEVEL_Q = 3 // 25% 容错率
    const val QRCODE_LEVEL_H = 4 // 30% 容错率
    const val PAPERSIZE_3 = 0 // 三寸纸张,76x156mm
    const val PAPERSIZE_4 = 1 // 四寸纸张,103x180mm

    const val SIZE_16 = 16
    const val SIZE_20 = 20
    const val SIZE_24 = 24
    const val SIZE_28 = 28
    const val SIZE_32 = 32
    const val SIZE_40 = 40
    const val SIZE_48 = 48
    const val SIZE_56 = 56
    const val SIZE_64 = 64
    const val SIZE_72 = 72
    const val SIZE_96 = 96

    const val TYPE_0 = "TEXT"
    const val TYPE_90 = "TEXT90"
    const val TYPE_180 = "TEXT180"
    const val TYPE_270 = "TEXT270"
    const val TYPE_TR = "TR"
    const val TYPE_TR90 = "TR90"
    const val TYPE_TR180 = "TR180"
    const val TYPE_TR270 = "TR270"

}