package com.fcbox.printer.opt

import com.fcbox.template.IPrintOpt


/**
 * @Description: 文本
 * @Author: luobin
 * @Date:   2021/4/26
 * @License: Copyright Since 2020 Hive Box Technology. All rights reserved.
 * @Notice: This content is limited to the internal circulation of Hive Box, 
 * and it is prohibited to leak or used for other commercial purposes.
 */
open class TextOpt : IPrintOpt {
    override var optCode = OptTable.OPT_CODE_TEXT

    private var x = 0.0// x轴起始坐标

    private var y = 0.0// y轴起始坐标

    private var fontType = 0 // 字体类型

    private var isBold = false // 是否加粗

    private var content: String? = null// 文字内容

    private var fontSizeMode: String = ""

    fun isBold(): Boolean {
        return isBold
    }

    fun getX(): Double {
        return x
    }

    fun getY(): Double {
        return y
    }

    fun getFontType(): Int {
        return fontType
    }

    fun getContent(): String? {
        return content
    }

    fun getFontSizeMode(): String {
        return fontSizeMode
    }

    fun setX(x: Double) {
        this.x = x
    }

    fun setY(y: Double) {
        this.y = y
    }

    fun setFontType(fontType: Int) {
        this.fontType = fontType
    }

    fun setContent(content: String?) {
        this.content = content
    }

    fun setFontSizeMode(fontSizeMode: String) {
        this.fontSizeMode = fontSizeMode
    }


    override fun setBaseXY(baseX: Int, baseY: Int) {
        setX(x + baseX)
        setY(y + baseY)
    }


    companion object {
        /**
         * @param x x轴起始坐标
         * @param y y轴起始坐标
         * @param fontType 字体类型 见 OptTable.FONT_TYPE_MATRX_16x16 等字体定义
         * @param isBold 是否加粗
         * @param content 文字内容
         */
        @JvmStatic
        fun create(
            x: Double, y: Double, fontType: Int, isBold: Boolean,
            content: String?
        ): TextOpt {
            val opt = TextOpt()
            opt.x = x
            opt.y = y
            opt.fontType = fontType
            opt.isBold = isBold
            opt.content = content
            return opt
        }
    }
}