package com.fcbox.printer.util

import com.fcbox.bluetooth.core.FcBluetoothManager
import com.fcbox.printer.BuildConfig
import java.io.UnsupportedEncodingException

/**
 * @Description: 指令发送
 * @Author: luobin
 * @Date:   2021/4/26
 * @License: Copyright Since 2020 Hive Box Technology. All rights reserved.
 * @Notice: This content is limited to the internal circulation of Hive Box, 
 * and it is prohibited to leak or used for other commercial purposes.
 */
object CommandSendUtil {

    val TAG = CommandSendUtil::class.java.simpleName
    private const val SIZE = 1000

    fun portSendCmd(cmd: String): Boolean {
        if (FcBluetoothManager.getInstance().isBluetoothOpen()) {

            val data: ByteArray = try {
                cmd.toByteArray(charset("GBK"))
            } catch (var6: UnsupportedEncodingException) {
                return false
            }

            if (BuildConfig.DEBUG) {
                PrintLogUtils.e(TAG, cmd)
            }

            var len = data.size
            while (true) {
                try {
                    Thread.sleep(10L)
                } catch (var5: InterruptedException) {
                    var5.printStackTrace()
                }
                if (len <= SIZE) {
                    return FcBluetoothManager.getInstance().sendDataByte(data, data.size - len, len)
                }
                if (!FcBluetoothManager.getInstance()
                        .sendDataByte(data, data.size - len, SIZE)
                ) {
                    return false
                }
                len -= SIZE
            }
        } else {
            return false
        }
    }
}