package com.fcbox.printer.util

import android.text.TextUtils
import java.util.*

object LineUtil {
    /**
     * @param text      文本，中文2 ，其余1
     * @param lineLimit 一行字数限制，以中文为单位
     * @param maxLine   最大行数
     * @return //case 1
     * String case1 = "12345678";
     * System.out.println(getMultiLineList(case1,2,2));
     * //case 2
     * String case2 = "123哈678";
     * System.out.println(getMultiLineList(case2, 2, 2));
     *
     *
     * //case 3
     * String case3 = "12345678";
     * System.out.println(getMultiLineList(case3,3,2));
     * //case 4
     * String case4 = "12345哈8";
     * System.out.println(getMultiLineList(case4,3,2));
     *
     *
     * //case 5
     * String case5 = "1234567891234";
     * System.out.println(getMultiLineList(case5,3,2));
     * System.out.println(getMultiLineList(case5,2,2));
     *
     *
     * //case 6
     * String case6 = "12345哈891哈4";
     * System.out.println(getMultiLineList(case6,3,2));
     */
    @JvmStatic
    fun getMultiLineList(
        text: String?,
        lineLimit: Int,
        maxLine: Int
    ): List<String> {
        val list = ArrayList<String>()
        if (text == null || lineLimit <= 0 || maxLine <= 0) {
            return list
        }
        //单行
        if (length(text) <= lineLimit * 2) {
            list.add(text)
            return list
        }

        val realLine =length(text) / (lineLimit * 2.0)

        if (realLine <= maxLine) {
            //整行
            if (length(text) % (lineLimit * 2) == 0) {
                val line = (length(text) / (lineLimit * 2.0)).toInt()
                var i = 0
                var index = 0
                var lineText = ""
                while (i < line && index < text.length) {

                    val singleText = text.subSequence(index, ++index)

                    lineText += singleText
                    // case 1
                    if (length(lineText) <= lineLimit * 2) {
                        if (length(lineText) == lineLimit * 2) {
                            ++i
                            list.add(lineText)
                            lineText = ""
                        }
                    } else { // case 2
                        ++i
                        --index
                        val result = lineText.substring(0, lineText.length - 1)
                        lineText = ""
                        list.add(result)
                    }
                }
            } else { //非整行
                val line = (length(text) / (lineLimit * 2.0)).toInt()
                var i = 0
                var index = 0
                var lineText = ""

                //先取整数部分的
                while (i < line && index < text.length) {
                    val singleText = text.subSequence(index,  ++index)
                    lineText += singleText
                    if (length(lineText) <= lineLimit * 2) { // case 3
                        if (length(lineText) == lineLimit * 2) {
                            ++i
                            list.add(lineText)
                            lineText = ""
                        }
                    } else { // case 4
                        ++i
                        --index
                        val result = lineText.substring(0, lineText.length - 1)
                        lineText = ""
                        list.add(result)
                    }
                }
                //余下的
                val singleText = text.substring(index)
                list.add(singleText)
            }
        } else {
            var i = 0
            var index = 0
            var lineText = ""
            //取小值的行数
            while (i < maxLine && index < text.length) {
                //这地方先+1；用++有问题
                val singleText = text.subSequence(index, ++index)

                lineText += singleText
                if (length(lineText) <= lineLimit * 2) { // case 5
                    if (length(lineText) == lineLimit * 2) {
                        ++i
                        list.add(lineText)
                        lineText = ""
                    }
                } else { // case 6
                    ++i
                    --index
                    val result = lineText.substring(0, lineText.length - 1)
                    lineText = ""
                    list.add(result)
                }
            }
            if (list.size > 0) {
                var lastLine = list.removeAt(list.size - 1)
                if (length(lastLine) > 3) {
                    val l2 = length(lastLine.substring(lastLine.length - 2))
                    lastLine = if (l2 >= 3) {
                        lastLine.substring(0, lastLine.length - 2) + "..."
                    } else {
                        lastLine.substring(0, lastLine.length - 3) + "..."
                    }
                }
                list.add(lastLine)
            }
        }
        return list
    }

    fun length(value: String): Int {
        var valueLength = 0
        if (TextUtils.isEmpty(value)) {
            return valueLength
        }
        val chinese = "[\u4e00-\u9fa5]"
        /* 获取字段值的长度，如果含中文字符，则每个中文字符长度为2，否则为1 */
        /* 获取字段值的长度，如果含中文字符，则每个中文字符长度为2，否则为1 */
        for (i in value.indices) {
            /* 获取一个字符 */
            val temp:String = value.substring(i, i + 1)
            /* 判断是否为中文字符 */

            valueLength += if (temp.matches(chinese.toRegex())) {
                /* 中文字符长度为2 */
                2
            } else {
                /* 其他字符长度为1 */
                1
            }
        }
        return valueLength
    }
}